package ca.carleton.ccsl.deadbolt;

import android.app.Activity;
import android.content.Intent;
import android.os.storage.IMountService;
import android.os.IBinder;
import android.os.RemoteException;
import android.os.ServiceManager;
import android.os.Handler;
import android.os.Message;
import android.os.Messenger;
import android.os.Bundle;
import android.os.SystemProperties;
import android.widget.EditText;
import android.widget.CheckBox;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.Button;
import android.view.View;
import android.view.Gravity;
import android.util.Log;


public class DeDeadbolt extends Activity {
	
	private static final String TAG = "Deadbolt.DeDeadbolt";

	private Handler handler = new Handler() {
		public void handleMessage(Message message) {
			
			int rc = message.arg1;

	  		//TODO: Switch over return codes and print error msgs

			 // if wrong password 
			 if (rc == -2) {
				Toast toast= Toast.makeText(getApplicationContext(), 
					"Error: Wrong Password!", Toast.LENGTH_SHORT);  
				toast.setGravity(Gravity.CENTER, 0, 0);
				toast.show();				
            	EditText mEdit = (EditText) findViewById(R.id.editText);
				mEdit.setText("", TextView.BufferType.EDITABLE);
			 }  		
		};
	};

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.dedeadbolt);

		String state = SystemProperties.get("cryptlock.lockstate");
		if (state.equals(MainActivity.SAFEMODE)) {
			
			final CheckBox call_log = (CheckBox) findViewById(R.id.checkBox1);
			call_log.setChecked(false);
			call_log.setEnabled(false);
			
			final CheckBox sms = (CheckBox) findViewById(R.id.checkBox2);			
			sms.setChecked(false);
			sms.setEnabled(false);	
					
			final CheckBox pictures = (CheckBox) findViewById(R.id.checkBox3);
			pictures.setChecked(false);
			pictures.setEnabled(false);
		}
	}

    public void onClick(View view) {
    	EditText mEdit = (EditText) findViewById(R.id.editText);
    	String passwd = mEdit.getText().toString();
		
		if ("".equals(passwd)) {
			Toast toast= Toast.makeText(getApplicationContext(), 
				"Password cannot be empty!", Toast.LENGTH_SHORT);  
			toast.setGravity(Gravity.CENTER, 0, 0);
			toast.show();				
        	return;
		}
		      		
		// get settings as bitstrings
		int flag = 0x00;
	
		final CheckBox call_log = (CheckBox) findViewById(R.id.checkBox1);
		if (call_log.isChecked())
			flag |= 0x01;
			
		final CheckBox sms = (CheckBox) findViewById(R.id.checkBox2);
		if (sms.isChecked())
			flag |= 0x02;
	
		final CheckBox pictures = (CheckBox) findViewById(R.id.checkBox3);
		if (pictures.isChecked())
			flag |= 0x04;

		Intent service = new Intent(getApplicationContext(), LockService.class);
		Messenger messenger = new Messenger(handler);
		service.putExtra("MESSENGER", messenger);
		service.putExtra("mode", 1);
		service.putExtra("flag", flag);
		service.putExtra("passwd", passwd);
		startService(service); 
    }
}
