package ca.carleton.ccsl.deadbolt;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.Messenger;
import android.content.Intent;
import android.view.View;
import android.view.Gravity;
import android.widget.CompoundButton;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;
import android.util.Log;


public class EnDeadbolt extends Activity {
	
	private static final String TAG = "Deadbolt.EnDeadbolt";

	private Handler handler = new Handler() {
		public void handleMessage(Message message) {
		  
		  int rc = message.arg1;
		  
			Toast toast= Toast.makeText(getApplicationContext(), 
				"Return Code" + message.arg1, Toast.LENGTH_LONG);  
			toast.setGravity(Gravity.CENTER, 0, 0);
			toast.show();
		
		  
		  //TODO: Switch over return codes and print error msgs

		};
	};

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.endeadbolt);
        
        
		/*
		 * SafeMode On/Off switch
		 * 
		 * 
		 */
        final Switch safemode = (Switch) findViewById(R.id.checkBox);
		safemode.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if (isChecked) {
					// safemode on
					final CheckBox contacts = (CheckBox) findViewById(R.id.checkBox2);
					contacts.setChecked(false);
					contacts.setEnabled(false);
		
					final CheckBox wifi = (CheckBox) findViewById(R.id.checkBox3);
					wifi.setChecked(false);
					wifi.setEnabled(false);
		
				} else {
					// safemode off
					final CheckBox contacts = (CheckBox) findViewById(R.id.checkBox2);
					contacts.setEnabled(true);

					final CheckBox wifi = (CheckBox) findViewById(R.id.checkBox3);
					wifi.setEnabled(true);
				}
			}
		});
	}
	
	
    public void onClick(View view) {

     	// get settings as bitstrings
		int flag = 0x00;

		final Switch safemode = (Switch) findViewById(R.id.checkBox);
		if (safemode.isChecked())
			flag |= 0xFF;
	
		final CheckBox contacts = (CheckBox) findViewById(R.id.checkBox2);
		if (contacts.isChecked())
			flag |= 0x01;

		final CheckBox wifi = (CheckBox) findViewById(R.id.checkBox3);
		if (wifi.isChecked())
			flag |= 0x02;

		Intent service = new Intent(getApplicationContext(), LockService.class);
		Messenger messenger = new Messenger(handler);
		service.putExtra("MESSENGER", messenger);
		service.putExtra("mode", 0);
		service.putExtra("flag", flag);
		startService(service); 
    }
}	
