package ca.carleton.ccsl.deadbolt;

import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.os.SystemProperties;
import android.util.Log;

public class MainActivity extends Activity {

    protected final static String UNLOCKED = "0";
    protected final static String LOCKED = "1";
    protected final static String SAFEMODE = "2";

    private final static String TAG = "Deadbolt.Main";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

	String state = SystemProperties.get("cryptlock.lockstate");

	Log.i(TAG, "Reading property cryptlock.lockstate:" + state);
	
        if (state.equals("") || state.equals(UNLOCKED) ){
            //we're in unlocked mode
            startActivity(new Intent(this, EnDeadbolt.class));
        }
        else if (state.equals(LOCKED)  || state.equals(SAFEMODE) ){
            //we're locked
            startActivity(new Intent(this, DeDeadbolt.class));
        }
        
        else {
		    // shouldnt happen
		    Log.e(TAG, "ERROR unexpected state:" + state);
		    finish();
        }
    }   
}
